<!doctype html>
<html lang='en'>

<head>
<meta charset='utf-8'>
<title>Regular Expressions</title>
<meta name='description' content='Plateforme de soutien à la recherche en sciences humaines et sociales'>
<meta name='author' content='Régis Witz'>
<meta name='apple-mobile-web-app-capable' content='yes'>
<meta name='apple-mobile-web-app-status-bar-style' content='black-translucent'>
<meta name='viewport' content='width=device-width, initial-scale=1.0'>
<link rel='stylesheet' href='dist/reset.css'>
<link rel='stylesheet' href='dist/reveal.css'>
<link rel='stylesheet' href='dist/theme/black.css' id='theme'>
<!-- Theme used for syntax highlighting of code -->
<link rel='stylesheet' href='plugin/highlight/monokai.css' id='highlight-theme'>
<style>
/* strong text is not always as visible as we'd want it to be,
   especially when streaming a video, so underline it
 */
strong { text-decoration: underline; }
</style>
</head>

<body>
<div class='reveal'>
<!-- Any section element inside of this container is displayed as a slide -->
<div class='slides'>



<section>
  <h1 class='r-fit-text'>Regular Expressions</h1>
  <blockquote cite='https://misha.fr/plateformes/plateforme-humanites-numeriques/'>
    <span style='font-style: normal;'> ^𓈖𓆓 𓊽*𓉐[𓉐 -𓈖]+𓏲𓇯𓂝𓏴𓃾 (𓉐𓃾??𓂝)𓂧𓁶𓃾 𓌓𓁶𓌓*(𓆓𓂝𓃾)* 𓌅𓃻{3,12}𓌅𓀠 𓀠𓇯𓈖𓃾 𓇯𓂧 $</span>
    <br><small style='margin: 0.5em 0 0 10em;'>Least unreadable regex</small>
  </blockquote>
  <div>
    <a href='https://creativecommons.org/licenses/by-nc-sa/4.0/deed'>
      <img data-src='https://licensebuttons.net/l/by-nc-sa/4.0/88x31.png' />
    </a>
  </div>
</section>



<!--
   //////////////////
  // INTRODUCTION //
 //////////////////
-->

<section data-transition='convex'>
  <h2>Why bother?</h2>
  <ul>
    <li class='fragment fade-in' data-fragment-index='1'>
	  <span class='fragment semi-fade-out' data-fragment-index='7'><strong>finding</strong> similar-looking strings</span>
    <ul>
	  <li class='fragment fade-in-then-semi-out' data-fragment-index='2'>same prefix, same suffix</li>
	  <li class='fragment fade-in-then-semi-out' data-fragment-index='3'>names</li>
	  <li class='fragment fade-in-then-semi-out' data-fragment-index='4'>dates, times</li>
	  <li class='fragment fade-in-then-semi-out' data-fragment-index='5'>adresses, URLs</li>
	  <li class='fragment fade-in-then-semi-out' data-fragment-index='6'>…</li>
    </ul>
    </li>
    <li class='fragment fade-in' data-fragment-index='7'>
	  <span class='fragment semi-fade-out' data-fragment-index='9'><strong>replacing</strong> these by something else</span>
    <ul><li class='fragment fade-in-then-semi-out' data-fragment-index='8'>reformat text</li></ul>
    </li>
    <li class='fragment fade-in' data-fragment-index='9'><strong>loading</strong> these in a database</li>
  </ul>
</section>

<section data-transition='convex'>
  <h2>A regex …</h2>
  <ul>
	  <li class='fragment fade-in-then-semi-out'>describes a <strong>set of possible strings</strong></li>
	  <li class='fragment fade-in'>using a <strong>formal</strong> syntax</li>
  </ul>
<aside class='notes'>
possible strings: words, sentences
<br>inside a regex, a character a context-specific meaning
</aside>
</section>

<section>

<section data-transition='convex'>
  <h2>Where?</h2>
  <ul>
	  <li class='fragment fade-in' data-fragment-index='1'>
	    <span class='fragment semi-fade-out' data-fragment-index='3'>in programming/scripting languages</span>
	    <ul><li class='fragment fade-in-then-semi-out' data-fragment-index='2'>Python, R, …</li></ul>
	  </li>
	  <li class='fragment fade-in' data-fragment-index='3'>
	    <span class='fragment semi-fade-out' data-fragment-index='5'>in text editors & spreadsheets</span>
	    <ul>
		  <li class='fragment fade-in-then-semi-out' data-fragment-index='4'><a href='https://www.geany.org/'>Geany</a>, <a href='https://notepad-plus-plus.org/'>Notepad++</a>, 💩<span style='text-decoration-line: line-through;'>Word</span>, <a href='https://www.libreoffice.org/discover/writer/'>Writer</a>, …</li>
		  <li class='fragment fade-in-then-semi-out' data-fragment-index='4'>💩<span style='text-decoration-line: line-through;'>Excel</span>, <a href='https://www.libreoffice.org/discover/calc/'>Calc</a>, …</li>
	    </ul>
	  </li>
	  <li class='fragment fade-in-then-semi-out' data-fragment-index='5'>
		<img style='display: inline; height: 1em; margin: 0;' src='https://seafile.unistra.fr/f/fadff2adb3e846a6a604/?dl=1'/>
		<a href='https://openrefine.org/'>OpenRefine</a>
	  </li>
	  <li class='fragment fade-in-then-semi-out' data-fragment-index='6'>
		<img style='display: inline; height: 1em; margin: 0;' src='https://txm.gitpages.huma-num.fr/textometrie/img/logo-txm.svg'/>
		<a href='https://txm.gitpages.huma-num.fr/textometrie/en/'>Textometry</a>
	  </li>
	  <li class='fragment fade-in' data-fragment-index='7'>…</li>
  </ul>
<aside class='notes'>
TXM is used for the analysis of large bodies of text <br>
search engines? Maybe, but <a href='https://www.youtube.com/watch?v=lYiTIDgejas'>not Google Search</a>
</aside>
</section>

<section data-transition='convex'>
  <h3><img src='https://seafile.unistra.fr/f/347a9c266c584a0d8a8a/?dl=1' style='display: inline; height: 1em; margin: 0 0.5em 0 0;'/>Notepad++</h3>
  <img src='https://seafile.unistra.fr/f/b73f9f0ddaf8460a86a5/?dl=1' />
</section>

<section data-transition='convex'>
  <h3><img src='https://seafile.unistra.fr/f/364cc4e65c104317850e/?dl=1' style='display: inline; height: 1em; margin: 0 0.5em 0 0;'/>Geany</h3>
  <img src='https://seafile.unistra.fr/f/f52488ffac6d4ca8a255/?dl=1' />
</section>

</section>



<!--
   //////////////
  // PRACTICE //
 //////////////
-->



<section>

<section data-transition='convex'>
  <h2>Let's do this!</h2>
  <img src='https://seafile.unistra.fr/f/91b77aae9ecb4cfdb0cc/?dl=1' style='height: 5em;' />
</section>

<section data-transition='convex'>
  <h3>Practice 'em!</h3>
  <ul>
    <li><a href='https://www.regex101.com/'>regex101.com</a></li>
    <li><a href='https://www.regexpal.com/'>regexpal.com</a></li>
    <li><a href='https://www.regexr.com/'>regexr.com</a></li>
    <li><a href='https://www.rstudio.com/'>RStudio</a></li>
  </ul>
<aside class='notes'>
regexpal might be a tad simpler ; regex101 a tad more complete
</aside>
</section>

</section>


<section data-transition='convex'>
  <h3 style='display: none; margin: 0;'>Cheat sheet</h3>
  <table style='font-size: 0.75em; width: 40em; margin-left: -5em;'>
      <thead>
        <tr>
            <th>Symbol</th>
            <th>Meaning</th>
            <th>Example</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td><code>\</code></td>
            <td>escape char</td>
            <td><code>\.</code> → dot char</td>
        </tr><tr>
            <td><code>.</code></td>
            <td>any char</td>
            <td><code>d.g</code> → "dig", "dog", "dug", …</td>
        </tr><tr>
            <td><code>?</code></td>
            <td>0 or once</td>
            <td><code>dou?gh?</code> → "dog" or "dough"</td>
        </tr><tr>
            <td><code>+</code></td>
            <td>once or more</td>
            <td><code>aw+!</code> → "aw!", "aww!", …, "awwwwwww!", …</td>
        </tr><tr>
            <td><code>*</code></td>
            <td>0 or more</td>
            <td><code>(blah )*</code> → "blah ", "blah blah blah", … or nothing</td>
        </tr><tr>
            <td><code>{x,y}</code></td>
            <td style='font-size: 0.7em; vertical-align: middle;'>between <code>x</code>and <code>y</code> times</td>
            <td><code>(xo){2,3}</code> → "xoxo" or "xoxoxo" but not "xo"</td>
        </tr><tr>
            <td><code>^</code></td>
            <td>line start</td>
            <td><code>^[0-9]</code> → any line starting with a digit</td>
        </tr><tr>
            <td><code>$</code></td>
            <td>line end</td>
            <td><code>^.$</code> → any line having only one char</td>
        </tr><tr>
            <td><code>[ ]</code></td>
            <td>char set</td>
            <td><code>[a-zA-Z]</code> → any non-diacritical letter</td>
        </tr><tr>
            <td><code>[^ ]</code></td>
            <td>complement</td>
            <td><code>[^0-9]</code> → any non-digit</td>
        </tr><tr>
            <td><code>( )</code></td>
            <td>group</td>
            <td><code>(yay|meh)</code> → "yay" or "meh"</td>
        </tr>
    </tbody>
  </table>
</section>


<!--
   ////////////////
  // CONCLUSION //
 ////////////////
-->

<section>

<section data-transition='convex'>
  <h2>Perspectives</h2>
</section>

<section data-transition='convex'>
  <h3>"Bibliography"</h3>
  <img src='https://seafile.unistra.fr/f/9d29aa3763354b15bc34/?dl=1' style='height: 30vh; margin-bottom: 0;' />
  <img src='https://seafile.unistra.fr/f/5eab4a476e0e4f1e8e9a/?dl=1' style='height: 30vh; margin-bottom: 0;' />
  <img src='https://seafile.unistra.fr/f/b1389ee99974442f9ab5/?dl=1' style='height: 30vh; margin-bottom: 0;' />
  <br>
  <img src='https://seafile.unistra.fr/f/90fb45c5c36245d5b263/?dl=1' style='height: 30vh; margin-top: 0;' />
  <img src='https://seafile.unistra.fr/f/546e12a0959e415daf0a/?dl=1' style='height: 30vh; margin-top: 0;' />
</section>

</section>

<section data-transition='convex'>
  <h3>Pros/Cons</h3>
  <ul>
  <li class='fragment fade-in-then-semi-out'>In some fields: out of fashion?</li>
  <li class='fragment fade-in-then-semi-out'>Simple and fast text recognition</li>
  <li class='fragment fade-in'>Simple to write, hard to read?
    <ul>
	<li class='fragment fade-in-then-semi-out'><strong>verbose</strong> regular expressions</li>
	<li class='fragment fade-in'>use <strong>functions</strong></li>
    </ul>
  </li>
  </ul>
<aside class='notes'>
Natural Language Processing (NLP): then regex, now ~neural networks<br>
Simple to write, hard to read

</aside>
</section>



<section data-transition='convex'>
<h2>regex use VS regex abuse</h2>

<p style='text-align: left;'>e-mail validation</p>
<pre>
<code data-trim data-line-numbers>
([\w-\.]+)@([\w-]+)\.+([\w-]{2,4})
</code>
</pre>

<p style='text-align: left;'><em>Robust</em> e-mail validation</p>
<pre>
<code data-trim data-line-numbers>
(?:(?:\r\n)?[ \t])*(?:(?:(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|"(?:[^\"\r\\]|\\.|(?:(?:\r\n)?[ \t]))*"(?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|"(?:[^\"\r\\]|\\.|(?:(?:\r\n)?[ \t]))*"(?:(?:\r\n)?[ \t])*))*@(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*))*|(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|"(?:[^\"\r\\]|\\.|(?:(?:\r\n)?[ \t]))*"(?:(?:\r\n)?[ \t])*)*\<(?:(?:\r\n)?[ \t])*(?:@(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*))*(?:,@(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*))*)*:(?:(?:\r\n)?[ \t])*)?(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|"(?:[^\"\r\\]|\\.|(?:(?:\r\n)?[ \t]))*"(?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|"(?:[^\"\r\\]|\\.|(?:(?:\r\n)?[ \t]))*"(?:(?:\r\n)?[ \t])*))*@(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*))*\>(?:(?:\r\n)?[ \t])*)|(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|"(?:[^\"\r\\]|\\.|(?:(?:\r\n)?[ \t]))*"(?:(?:\r\n)?[ \t])*)*:(?:(?:\r\n)?[ \t])*(?:(?:(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|"(?:[^\"\r\\]|\\.|(?:(?:\r\n)?[ \t]))*"(?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|"(?:[^\"\r\\]|\\.|(?:(?:\r\n)?[ \t]))*"(?:(?:\r\n)?[ \t])*))*@(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*))*|(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|"(?:[^\"\r\\]|\\.|(?:(?:\r\n)?[ \t]))*"(?:(?:\r\n)?[ \t])*)*\<(?:(?:\r\n)?[ \t])*(?:@(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*))*(?:,@(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*))*)*:(?:(?:\r\n)?[ \t])*)?(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|"(?:[^\"\r\\]|\\.|(?:(?:\r\n)?[ \t]))*"(?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|"(?:[^\"\r\\]|\\.|(?:(?:\r\n)?[ \t]))*"(?:(?:\r\n)?[ \t])*))*@(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*))*\>(?:(?:\r\n)?[ \t])*)(?:,\s*(?:(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|"(?:[^\"\r\\]|\\.|(?:(?:\r\n)?[ \t]))*"(?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|"(?:[^\"\r\\]|\\.|(?:(?:\r\n)?[ \t]))*"(?:(?:\r\n)?[ \t])*))*@(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*))*|(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|"(?:[^\"\r\\]|\\.|(?:(?:\r\n)?[ \t]))*"(?:(?:\r\n)?[ \t])*)*\<(?:(?:\r\n)?[ \t])*(?:@(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*))*(?:,@(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*))*)*:(?:(?:\r\n)?[ \t])*)?(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|"(?:[^\"\r\\]|\\.|(?:(?:\r\n)?[ \t]))*"(?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|"(?:[^\"\r\\]|\\.|(?:(?:\r\n)?[ \t]))*"(?:(?:\r\n)?[ \t])*))*@(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*)(?:\.(?:(?:\r\n)?[ \t])*(?:[^()<>@,;:\\".\[\] \000-\031]+(?:(?:(?:\r\n)?[ \t])+|\Z|(?=[\["()<>@,;:\\".\[\]]))|\[([^\[\]\r\\]|\\.)*\](?:(?:\r\n)?[ \t])*))*\>(?:(?:\r\n)?[ \t])*))*)?;\s*)
</code>
</pre>
<small>6,343 characters regex for validating <a href='http://www.ex-parrot.com/~pdw/Mail-RFC822-Address.html'>RFC822</a> email addresses, via <a href='https://blog.codinghorror.com/regex-use-vs-regex-abuse/'>Jeff Artwood</a></small>

<aside class='notes'>
this somewhat pushes the limits of what it is sensible to do with regular expressions
</aside>
</section>



<section data-transition='convex-in' data-auto-animate>
  <h3>Comments</h3>
  <pre data-id="regex-refactor" style='width: 60vw;'>
    <code class='r' data-trim data-line-numbers>
email <- "john.diddle-doe@univ.grenoble-alpes.fr"
expr <- "([[:alnum:].-]+)@([[:alnum:]-.]+).([[:alnum:]-]{2,4})"
str_match(email, expr)
    </code>
  </pre>
</section>
<section data-transition='convex-out' data-auto-animate>
  <h3>Comments</h3>
  <pre data-id="regex-refactor" style='width: 60vw;'>
    <code class='r' data-trim data-line-numbers="|2-8">
email <- "john.diddle-doe@univ.grenoble-alpes.fr"
expr <- regex("
  ([[:alnum:].-]+)    # username / local name (everything before @)
  @
  ([[:alnum:].-]+)    # webmail provider (without extension)
  .                   # dot character
  ([[:alnum:]-]{2,4}) # domain extension
  ", comments = TRUE)
str_match(email, expr)
    </code>
  </pre>
</section>



<section data-transition='convex-in' data-auto-animate>
  <h3>Modularity</h3>
  <pre data-id="regex-refactor" style='width: 60vw;'>
    <code class='r' data-trim data-line-numbers>
email <- "john.diddle-doe@univ.grenoble-alpes.fr"
expr <- "([[:alnum:].-]+)@([[:alnum:]-.]+).([[:alnum:]-]{2,4})"
str_match(email, expr)
    </code>
  </pre>
</section>
<section data-transition='convex-out' data-auto-animate>
  <h3>Modularity</h3>
  <pre data-id="regex-refactor" style='width: 60vw;'>
    <code class='r' data-trim data-line-numbers="|2,5,8|11|3,6">
email <- "john.diddle-doe@univ.grenoble-alpes.fr"
username <- function(x) {
  return ("([[:alnum:].-]+)")
}
provider <- function(x) {
  return ("([[:alnum:]-.]+)")
}
extension <- function(x) {
  return ("([[:alnum:]-]{2,4})")
}
expr <- str_c(username(),"@",provider(),".",extension())
str_match(email, expr)
    </code>
  </pre>
</section>



<!--
   /////////////
  // ENDGAME //
 /////////////
-->

<section>

<section style='text-align: left;'
  data-background='https://seafile.unistra.fr/f/0239ee5679c34736822e/?dl=1'
  >
  <div style='box-shadow: 0 1px 4px rgba(0,0,0,0.5), 0 5px 25px rgba(0,0,0,0.2); background-color: rgba(0, 0, 0, 0.9); padding: 20px;'>
    <h2>Who ami I ?</h2>
    <p><a href='mailto:phun@misha.fr'>phun@misha.fr</a></p>
    <p>
      <small>
      Maison Interuniversitaire des Sciences de l’Homme - Alsace | MISHA<br/>
      5 allée du Général Rouvillois - CS 50008 - 67083 Strasbourg cedex<br/>
      </small><br/>
      <strong>Bureau 141</strong>
    </p>
  </div>
</section>

<section style='text-align: left;'>
<h2>Image credits</h2>
<p>
Images:<br>
  <small>
  <em>Construction abstraite passée et future</em> (<a href='http://www.insa-strasbourg.fr/fr/laurent-reynes/'>Laurent Reynès</a>),
  <a href='https://github.com/thepracticaldev/orly-full-res'>@ThePracticalDev</a>
  </small>
</p>
<p>
Logos:
<small><em>The trademarks and logos used in this presentation belong to their respective owners.</em></small>
</p>

<h2>Licence</h2>
<small>
  This presentation is made available by <a href='https://orcid.org/0000-0002-8064-0977'>Régis Witz</a> (<a href='mailto:rwitz@unistra.fr'>rwitz@unistra.fr</a>) under the terms of the 
  <em>Creative Commons Attribution - Non Commercial - ShareAlike 4.0 International</em> license.
</small>
<a href='https://creativecommons.org/licenses/by-nc-sa/4.0/deed'>
  <img data-src='https://licensebuttons.net/l/by-nc-sa/4.0/88x31.png' />
</a>
</section>

</section>

</div>

</div>

<script src='dist/reveal.js'></script>
<script src='plugin/zoom/zoom.js'></script>
<script src='plugin/notes/notes.js'></script>
<script src='plugin/search/search.js'></script>
<script src='plugin/markdown/markdown.js'></script>
<script src='plugin/highlight/highlight.js'></script>
<script>

// Also available as an ES module, see:
// https://revealjs.com/initialization/
Reveal.initialize({
  controls: true,
  progress: true,
  center: true,
  hash: true,

  // Learn about plugins: https://revealjs.com/plugins/
  plugins: [ RevealZoom, RevealNotes, RevealSearch, RevealMarkdown, RevealHighlight ]
});

</script>

</body>
</html>

